package com.zh.project0512.mapper;

import com.alibaba.fastjson.JSONObject;
import com.zh.project0512.model.ReferenceBrand;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2022-05-25
 */
public interface ReferenceBrandMapper extends BaseMapper<ReferenceBrand> {
    @Insert("<script> " +
        "insert into referenceBrand (referenceId,brandId) values\n"+
        "  <foreach collection= 'list' item= 'item'  separator=','>\n" +
        "(#{item.referenceId},#{item.brandId})\n"+
        "</foreach> \n"+
        "</script>")
    void addGroup(List<JSONObject> list);
    @Select("select brand.id,brand.name from referenceBrand,brand where referenceBrand.referenceId = #{id} and brand.id = referenceBrand.brandId")
    List<Map> selByReferenceId(int id);
}
