package com.zh.project0512.mapper;

import com.zh.project0512.model.TaskBrand;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2022-05-26
 */
public interface TaskBrandMapper extends BaseMapper<TaskBrand> {
    @Insert("<script> " +
        "insert into taskBrand (taskId,brandId) values\n"+
        "  <foreach collection= 'list' item= 'item'  separator=','>\n" +
        "(#{taskId},#{item})\n"+
        "</foreach> \n"+
        "</script>")
    void addGroup(List list, int taskId);
    @Select("select t2.id,t2.name from taskBrand as t1,brand as t2 where t1.taskId = #{id} and t1.brandId = t2.id")
    List<Map> listByTaskId(int id);
}
