package com.zh.project0512.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zh.project0512.model.User;
import com.zh.project0512.model.UserEffectRecords;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2022-06-30
 */
public interface UserEffectRecordsMapper extends BaseMapper<UserEffectRecords> {
    @Select("INSERT into userEffectRecords " +
        "(userId,departmentId,effectResultTran,createAt) " +
        " VALUES " +
        "(#{userId},(SELECT main_department from user WHERE id  = #{userId}),#{effectResultTran},#{createAt})")
    void saveEffectResult(UserEffectRecords userEffectRecords);

    //    @Select("SELECT t1.departmentId,t3.name as title,IFNULL(sum(t1.effectResultTran),0) as effectValue from userEffectRecords as t1\n" +
//        "INNER JOIN qywxDepartment as t3 on t3.departmentId = t1.departmentId\n" +
//        "${ew.customSqlSegment} " +
//        "GROUP BY departmentId\n" +
//        "ORDER BY effectValue DESC")
    @Select("SELECT t1.departmentId,t1.name,IFNULL(sum(t2.effectValue),0) as effectValue from (SELECT t1.*,t2.openid FROM qywxDepartment t1 LEFT JOIN qywxDepartmentUserLink as t2 on t2.departmentId = t1.departmentId)  as t1\n" +
        "INNER JOIN (SELECT t1.openid,IFNULL(sum(t2.effectResultTran),0) as effectValue  from user t1 left join userEffectRecords t2 on t2.userId = t1.id GROUP BY openid) as t2 on t2.openid = t1.openid\n" +
        "${ew.customSqlSegment} " +
        "GROUP BY departmentId\n" +
        "ORDER BY effectValue DESC")
    IPage<Map> rankByDepartment(IPage page, @Param("ew") Wrapper<UserEffectRecords> queryWrapper);

    @Select("SELECT t1.userId,t2.name as title,t2.avatar,t2.departmentId,t2.departmentName as subtitle,IFNULL(sum(t1.effectResultTran),0) as effectValue from userEffectRecords as t1\n" +
        "INNER JOIN (SELECT t1.id,t1.name,t1.avatar,t2.departmentId,t2.name as departmentName FROM user as t1 left join qywxDepartment as t2 on t1.main_department = t2.departmentId) as t2 on t1.userId = t2.id\n" +
        "${ew.customSqlSegment} " +
        "GROUP BY userId\n" +
        "ORDER BY effectValue DESC")
    IPage<Map> rankByUser(IPage page, @Param("ew") Wrapper<UserEffectRecords> queryWrapper);
}
