package com.zh.project0512.mapper;

import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.zh.project0512.model.Reference;
import com.zh.project0512.model.User;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author zh
 * @since 2022-05-18
 */
public interface UserMapper extends BaseMapper<User> {
    @Select("SELECT * FROM user where openid=#{openid} ")
    User selByOpenid(@Param("openid") String openid);

    @Select("SELECT t1.*,t2.name as departmentName FROM user t1 left join qywxDepartment t2 on  t1.main_department = t2.departmentId where openid=#{openid} ")
    Map selByOpenid2(@Param("openid") String openid);

    @Select("UPDATE user set token=#{token},lastLoginAt=#{time} where openid=#{openid}")
    void updByOpenid(String openid, String token, LocalDateTime time);

//    @Select("SELECT t1.id,t1.name,t1.tel,t1.avatar,t1.main_department,t1.sub_department,t1.points,t1.historyPoints,t1.creatAt,t1.updateAt,t1.lastLoginAt" +
//        ",t2.name as main_departmentName,t3.name as sub_departmentName,t4.departmentId as dpId,t4.department " +
//        "from user as t1 " +
//        "left join qywxDepartment as t2 on t1.main_department = t2.departmentId " +
//        "left join qywxDepartment as t3 on t1.sub_department = t3.departmentId " +
//        "left join (SELECT t.*,d.name as department from qywxDepartmentUserLink t left join qywxDepartment d on t.departmentId = d.departmentId) as t4 on t1.openid = t4.openid " +
//        "${ew.customSqlSegment} " +
//        "ORDER BY lastLoginAt DESC,updateAt DESC,creatAt DESC")
    IPage<Map> userDpList(IPage iPage, @Param("ew") Wrapper<User> queryWrapper);

    @Update("UPDATE user set points = points + #{record},historyPoints = historyPoints + #{record} WHERE id = #{userId}")
    void updPoints(int userId, int record);
}
