package com.zh.project0512.model;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * <p>
 *
 * </p>
 *
 * @author zh
 * @since 2022-05-30
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("customerActionNote")
@Schema(title = "用户行为记录")
public class CustomerActionNote extends Model {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 客户姓名
     */
    @Schema(title = "用户姓名")
    @TableField("customerName")
    private String customerName;

    private String tel;

    /**
     * 地区
     */
    @Schema(title = "地区")
    private String area;

    @Schema(title = "关联品牌列表")
    @TableField("brandList")
    private String brandList;

    /**
     * 备注
     */
    @Schema(title = "备注")
    private String remarks;

    /**
     * 提供用户id
     */
    @Schema(title = "提供用户id")
    @TableField("provideId")
    private Integer provideId;

    @Schema(title = "相关任务的id")
    @TableField("taskId")
    private Integer taskId;

    @TableField("creatAt")
    private LocalDateTime creatAt;


}
