package com.zh.project0512.model;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.annotation.TableId;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotNull;

/**
 * <p>
 *
 * </p>
 *
 * @author zh
 * @since 2022-05-23
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("rewardRule")
@Schema
public class RewardRule extends Model {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 奖励积分
     */
    @Schema(title = "奖励积分")
    @NotNull(message = "reward不能为空")
    private Integer reward;

    /**
     * 所属模版id
     */
    @Schema(title = "所属模版id")
    @TableField("templateId")
    private Integer templateId;

    /**
     * 临界值
     */
    @Schema(title = "limitNum")
    @NotNull(message = "临界值不能为空")
    @Min(value = 0,message = "临界值不能小于0")
    private Integer limitNum;


    /**
     * 创建时间
     */
    @TableField("creatAt")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime creatAt;

}
