package com.zh.project0512.model;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.time.LocalDateTime;

/**
 * <p>
 *
 * </p>
 *
 * @author zh
 * @since 2022-05-18
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
public class Video extends Model {

    private static final long serialVersionUID = 1L;

    @TableId(value = "id", type = IdType.AUTO)
    private Integer id;

    /**
     * 视频地址
     */
    private String url;

    /**
     * 平台：1抖音；2快手；3朋友圈；4视频号
     */
    private Integer type;

    /**
     * 视频标签id
     */
    @TableField("tagId")
    private Integer tagId;

    /**
     * 上传者id
     */
    @TableField("userId")
    private Integer userId;

    /**
     * 任务id
     */
    @TableField("taskId")
    private Integer taskId;

    /**
     * 视频审核状态：0待任务结束；1待审核；2审核通过；3审核拒绝
     */
    @TableField("status")
    private Integer status;
    /**
     * 播放次数
     */
    @TableField("playNum")
    private Integer playNum;

    /**
     * 点赞次数
     */
    @TableField("commendNum")
    private Integer commendNum;

    /**
     * 收藏次数
     */
    @TableField("collectionNum")
    private Integer collectionNum;

    /**
     * 评论次数
     */
    @TableField("commentNum")
    private Integer commentNum;

    /**
     * 转发次数
     */
    @TableField("reSendNum")
    private Integer reSendNum;

    /**
     * 推荐次数
     */
    @TableField("recommendNum")
    private Integer recommendNum;

    @Schema(title = "拒绝理由")
    private String reason;

    @Schema(title = "影响值计算结果")
    @TableField("effectResult")
    private Integer effectResult;

    @TableField("creatAt")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime creatAt;

    @TableField("updateAt")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime updateAt;

    /**
     * 是否结算:0否1是
     */
    @TableField("isSettled")
    private Integer isSettled;

    /**
     * 结算时间
     */
    @TableField("settledAt")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime settledAt;

}
