package com.zh.project0512.model.dto;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotNull;
import java.io.Serializable;

/**
 * 用户角色 list DTO
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Schema
public class AdminRoleListDTO implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * 当前页数
     */
    @Schema(title = "当前页数")
    @NotNull(message = "当前页数不能为空")
    private int pageNum;
    /**
     * 每页记录数
     */
    @Schema(title = "每页记录数")
    @NotNull(message = "每页记录数不能为空")
    private int pageSize;
    /**
     * 角色名
     */
    private String name;
}
