package com.zh.project0512.model.dto;

import com.baomidou.mybatisplus.annotation.TableField;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * 排行列表DTO
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
@Schema
public class RankListDTO implements Serializable {
    private static final long serialVersionUID = 1L;

    /**
     * 当前页数
     */
    @Schema(title = "当前页数")
    @NotNull(message = "当前页数不能为空")
    private int pageNum;
    /**
     * 每页记录数
     */
    @Schema(title = "每页记录数")
    @NotNull(message = "每页记录数不能为空")
    private int pageSize;
    /**
     * 排行榜类型：1.经销商，2.员工
     */
    @Schema(title = "排行榜类型",description = "1.经销商，2.员工")
    @NotNull(message = "排行榜类型不能为空")
    private int type;
    @Schema(title = "查询年月",description = "时间格式为yyyy-MM-dd HH:mm:ss")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime dateTime;
}
